/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.quartzcore.CVOpenGLBuffer;

import dstep.corefoundation.CFBase;
import dstep.corefoundation.CFDictionary;
import dstep.corevideo.CVOpenGLBuffer;
import dstep.corevideo.CVImageBuffer;
import dstep.opengl.CGLTypes;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

//import bindings = dstep.quartzcore.CVOpenGLBuffer_bindings;

alias CVImageBufferRef CVOpenGLBufferRef;

extern (C)
{
	extern
	{
		const CFStringRef kCVOpenGLBufferWidth;
		const CFStringRef kCVOpenGLBufferHeight;
		const CFStringRef kCVOpenGLBufferTarget;
		const CFStringRef kCVOpenGLBufferInternalFormat;
		const CFStringRef kCVOpenGLBufferMaximumMipmapLevel;
	}
}

extern (C)
{
	uint CVOpenGLBufferGetTypeID ();
	CVOpenGLBufferRef CVOpenGLBufferRetain (CVOpenGLBufferRef buffer);
	void CVOpenGLBufferRelease (CVOpenGLBufferRef buffer);
	int CVOpenGLBufferCreate (CFAllocatorRef allocator, uint width, uint height, CFDictionaryRef attributes, CVOpenGLBufferRef* bufferOut);
	CFDictionaryRef CVOpenGLBufferGetAttributes (CVOpenGLBufferRef openGLBuffer);
	int CVOpenGLBufferAttach (CVOpenGLBufferRef openGLBuffer, CGLContextObj cglContext, uint face, int level, int screen);
}